## dose3 5.0

=== debian/changelog ===
dose3 (5.0-3~bpo8+1) jessie-backports; urgency=medium

  * backport to Debian Jessie

 -- Ralf Treinen <treinen@debian.org>  Thu, 21 Jul 2016 12:01:39 +0200

dose3 (5.0-3) unstable; urgency=medium

  * d/rules: make build-indep depend on configure-stamp

 -- Ralf Treinen <treinen@debian.org>  Fri, 15 Jul 2016 22:55:36 +0200

dose3 (5.0-2) unstable; urgency=medium

  * patch distcheck-fg-bg: fix calculation of the list of packages to check
    by distcheck in case of both --bg and --fg arguments (closes: #830957).
  * patch getrealname: fix the function get_real_name to remove both a
    --virtual prefix and an :architecture suffix in case both are present.
    This fixes a crash during the generation of explanations observed by
    wanna-build.
  * added NEWS item for dose-distcheck and dose-builddebcheck
    about --latest now taking an integer argument.

 -- Ralf Treinen <treinen@debian.org>  Fri, 15 Jul 2016 19:08:14 +0200

dose3 (5.0-1~bpo8+1) jessie-backports; urgency=medium

  [ Johannes Schauer ]
  * backport to Debian Jessie

 -- Ralf Treinen <treinen@debian.org>  Wed, 29 Jun 2016 14:44:27 +0200

dose3 (5.0-1) unstable; urgency=medium

  * new upstream release

 -- Ralf Treinen <treinen@debian.org>  Wed, 22 Jun 2016 20:07:10 +0200

dose3 (5.0~rc2-1) experimental; urgency=medium

  * new upstream release:
    - refreshed patch binaries-prefix-edos
    - dropped patches integrated by upstream:
      0001-applications-apt-cudf.ml-Do-not-generate-removal-req.patch
      0001-fix-licence-header.patch
  * specify minimum version 1.1.2 for build-dependency "cppo", following
    upstream instructions.

 -- Ralf Treinen <treinen@debian.org>  Sun, 19 Jun 2016 20:50:45 +0200

dose3 (4.3-3) experimental; urgency=medium

  * dose-doc: breaks older versions of apt-cudf, libdose3-ocaml-dev,
    dose-distcheck (closes: #826690).

 -- Ralf Treinen <treinen@debian.org>  Wed, 08 Jun 2016 04:49:39 +0200

dose3 (4.3-2) experimental; urgency=medium

  * New binary package dose-doc. Split debian/rules targets into -arch
    and -indep; split off Build-Depends-Indep from Build-Depends.
  * change doc-base section of the apt-cudf primer to System/Package Management
  * d/rules: simplify override for dh_auto_clean, create file debian/clean

 -- Ralf Treinen <treinen@debian.org>  Mon, 06 Jun 2016 19:46:11 +0200

dose3 (4.3-1) experimental; urgency=medium

  [ Ralf Treinen ]
  * New upstream version.
  * Drop patch lexing-debian-fields: applied upstream
  * Standards-Version 3.9.8 (no change)

  [ Johannes Schauer ]
  * Drop patch disable_dot because #809049 has been fixed. Restore build
    dependency on graphviz.
  * Add patch 0001-applications-apt-cudf.ml-Do-not-generate-removal-req from
    upstream git master to let apt-cudf not create a removal request for
    upgrades or downgrades but only a single install request. See the patch
    description as well as the closed bug for details (closes: #823906)
  * Refreshed patch binaries-prefix-edos
  * Clarify copyright situation of scripts/pack.ml in debian/copyright and
    patch the copyright header of scripts/pack.ml accordingly with a new patch
    called 0001-fix-licence-header.patch

 -- Johannes Schauer <josch@debian.org>  Fri, 13 May 2016 19:08:41 +0200

dose3 (4.2-2) unstable; urgency=medium

  * Dropped the Testsuite field in d/control, as it is no longer needed.
  * d/copyright:
    - updated filename versioning/debian.ml
    - removed duplicate paragraph for debian/update-cudf-solvers
  * Vcs-git: replaced insecure git: URI by https:
  * patch disable-dot: add Author and Description

 -- Ralf Treinen <treinen@debian.org>  Sun, 03 Apr 2016 22:04:33 +0200

dose3 (4.2-1) experimental; urgency=medium

  * New upstream version. This version fixes a bug in the manpage of
    dose-builddebcheck (closes: #811248)
    - refreshed patches:
      * binaries-prefix-edos
      * disable_dot
    - dropped patches integrated by upstream:
      * fix_ftbfs_on_bytecode_arch
      * fix_META
      * cudf_max_int
   * fixed patch add-gnuhardened1-linux, thanks to Balint Reczey
     (closes: #812786, again)
   * d/rules: upstream has renamed manpage buildcheck into deb-buildcheck
   * d/*.NEWS: say that format version of yaml output has been bumped
   * drop build-dependency on graphviz, since generation of dot files is
     deliberately disabled (by patch disable_dot).
   * Standards-Version 3.9.7 (no change)
   
 -- Ralf Treinen <treinen@debian.org>  Wed, 10 Feb 2016 08:50:18 +0100

dose3 (4.1~beta1-2) experimental; urgency=medium

  * add patch fix-doc-target-without-ocamlopt.patch to make dose3 build on
    architectures without ocamlopt

 -- Johannes Schauer <josch@debian.org>  Sat, 26 Dec 2015 16:29:13 +0100

=== debian/control ===
Source: dose3
Section: ocaml
Priority: extra
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stefano Zacchiroli <zack@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Johannes Schauer <josch@debian.org>
Build-Depends: debhelper (>= 9), dh-ocaml (>= 0.9~), dh-autoreconf,
# use the following line only when autoconf stuff has been patched:
# automake, autoconf,
 ocaml-nox (>= 3.11.2), cppo (>= 0.9.3),
 libre-ocaml-dev,
 libextlib-ocaml-dev (>= 1.6.1),
 libocamlgraph-ocaml-dev (>= 1.8.5),
 libcudf-ocaml-dev (>= 0.7),
 libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.12),
 perl 
Build-Depends-Indep: graphviz,
 hevea, texlive-latex-base, texlive-latex-extra
Standards-Version: 3.9.8
Homepage: http://www.mancoosi.org/software/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/dose3.git
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/dose3.git

Package: libdose3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (development files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains the development stuff you need to use dose3 for
 the development of programs.

Package: libdose3-ocaml
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends} 
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (runtime files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions. 
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains only the shared runtime stub libraries.

Package: dose-distcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: dose3-distcheck (<< 2.9.13)
Replaces: dose3-distcheck (<< 2.9.13)
Description: Checks whether dependencies of packages can be satisfied
 This software checks for every package of a distribution whether it
 is possible to satisfy its dependencies and conflicts within this
 distribution. It comes in several versions:
  - dose-debcheck for Debian packages
  - dose-rpmcheck for rpm packages
  - dose-eclipsecheck for OSGi plugins

Package: dose-builddebcheck
Section: devel
Architecture: any
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Breaks: dose3-builddebcheck (<< 2.9.13)
Replaces: dose3-builddebcheck (<< 2.9.13)
Description: Checks whether build-dependencies can be satisfied
 This software checks, given a collection of source package stanzas
 and a collection of binary package stanzas of Debian packages, whether
 the build-dependencies of each source package can be satisfied by the
 binary packages.

Package: dose-extra
Section: devel
Architecture: any
Provides: ceve
Breaks: ceve (<< 2.9.10)
Replaces: ceve (<< 2.9.10)
Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Extra QA tools from the Dose3-library
 This package contains extra tools for analyzing meta-data of software 
 packages:
  - ceve, a general metadata parser supporting different input formats
    (Debian, rpm, and others) and different output formats.
  - dose-outdated, a Debian-specific tool for finding packages that are not
    installable with respect to a package repository, and that can only be
    made installable again by fixing the package itself.
  - dose-challenged, a Debian-specific tool for checking which packages
    will certainly become uninstallable when some existing package is upgraded
    to a newer version.
  - dose-deb-coinstall, a Debian-specific tool for checking whether a set of
    packages can be installed all together.
 The tools dose-distcheck and dose-builddebcheck are packaged in their
 own resepective packages.

Package: apt-cudf
Section: admin
Architecture: any
Depends: aspcud | cudf-solver,
 ${ocaml:Depends}, ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: CUDF solver integration for APT
 apt-cudf provides integration among the APT package manager and CUDF solvers,
 allowing APT to rely on external (CUDF-based) dependency solvers to plan
 package installation, upgrade, and removal.
 .
 CUDF is a distribution-independent, standard format to describe dependency
 solving scenarios, as faced by package managers in popular package-based
 GNU/Linux distributions. APT is a well-known package manager for Debian-based
 distributions, which is able to delegate dependency solving to external
 solvers, by the means of the External Dependency Solving Protocol (EDSP).
 .
 apt-cudf provides the glue between the EDSP protocol and CUDF solvers,
 enabling any installed CUDF solver to be used as an external solver for APT.
 .
 Several CUDF solvers are available in Debian. They all provide the cudf-solver
 virtual package.

Package: dose-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: libdose3-ocaml-dev (<< 4.3-2),
	  apt-cudf (<< 4.3-2),
	  dose-distcheck (<< 4.3-2)
Breaks: libdose3-ocaml-dev (<< 4.3-2),
	  apt-cudf (<< 4.3-2),
	  dose-distcheck (<< 4.3-2)
Description: Documentation for dose tools and libraries.
 The dose suite provides libraries for handling package meta-data, and various
 tools for analyzing package relationships in a large package repository.
 This package contains the documentation of the dose API, and tutorials of
 various dose tools.

## dose3 5.0.1

=== Makefile ===
#this is a forward reference to the target all below
all: all

#SHELL=/bin/bash
include Makefile.config

DIST_DIR = $(NAME)-$(VERSION)
DIST_TARBALL = $(DIST_DIR).tar.gz

#VERBOSE := -classic-display
OBFLAGS := $(VERBOSE) -j 10 -no-links -cflags -warn-error,FPSXY
APPFLAGS := $(VERBOSE) -j 10
#OBFLAGS := $(OBFLAGS) -tag debug
#OBFLAGS := $(OBFLAGS) -tag profile
#OBFLAGS := $(OBFLAGS) -classic-display

addnotrpm:
	@if [ ! -s doseparseNoRpm ]; then $(LN) doseparse doseparseNoRpm ; fi
	@cd doseparse ; \
		if [ ! -s doseparseNoRpm.mlpack ]; then \
			$(LN) doseparse.mlpack doseparseNoRpm.mlpack ; \
		fi ; \
	cd -

myocamlbuild.ml: myocamlbuild.ml.pp
	cppo $(CPPOFLAGS) $< -o $@

all: libs apps man

apps: addnotrpm myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) 
	$(OCAMLBUILD) $(APPFLAGS) applications/apps.otarget

libs: addnotrpm myocamlbuild.ml itarget $(BYTELIBS) $(OPTLIBS) $(CMXSLIBS) $(ALIBS)

cleandoselib:
	rm -Rf $(DOSELIBS)

itarget:
	@rm -f applications/apps.itarget
	@for i in $(TARGETS); do echo $$i >> applications/apps.itarget; done
	@$(shell \
		for lib in $(LIBNAMES); do \
			libname=`basename "$$lib"` ;\
			dirname=`dirname "$$lib"` ;\
			rm -f $$dirname/$$libname.itarget ;\
			for ext in $(SUFFIX); do \
				echo "$$libname.$$ext" >> $$dirname/$$libname.itarget; \
			done;\
		done)

$(DOSELIBS)/cudf.%:
	$(OCAMLBUILD) $(OBFLAGS) cudf/cudf.$*
	@mkdir -p $(DOSELIBS)
	@cp _build/cudf/*.cmi $(DOSELIBS)
	@rm _build/cudf/*.cmi
	@for i in _build/cudf/cudf.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/common.%: common/*.ml common/*.mli
	$(OCAMLBUILD) $(OBFLAGS) common/common.otarget
	@mkdir -p $(DOSELIBS)
	@for i in _build/common/common.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/versioning.%: versioning/*.ml versioning/*.mli
	$(OCAMLBUILD) $(OBFLAGS) versioning/versioning.otarget
	@mkdir -p $(DOSELIBS)
	@for i in _build/versioning/versioning.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/algo.%: algo/*.ml algo/*.mli $(DOSELIBS)/common.%
	$(OCAMLBUILD) $(OBFLAGS) algo/algo.otarget
	@for i in _build/algo/algo.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/debian.%: deb/*.ml deb/*.mli $(DOSELIBS)/pef.%
	$(OCAMLBUILD) $(OBFLAGS) deb/debian.otarget
	@for i in _build/deb/debian.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/opam.%: opam/*.ml opam/*.mli $(DOSELIBS)/pef.%
	$(OCAMLBUILD) $(OBFLAGS) opam/opam.otarget
	@for i in _build/opam/opam.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/npm.%: npm/*.ml npm/*.mli $(DOSELIBS)/versioning.% $(DOSELIBS)/pef.%
	$(OCAMLBUILD) $(OBFLAGS) npm/npm.otarget
	@for i in _build/npm/npm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/rpm.%: rpm/*.ml $(DOSELIBS)/algo.%
	$(OCAMLBUILD) $(OBFLAGS) rpm/rpm.otarget
	@for i in _build/rpm/rpm.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/pef.%: pef/*.ml pef/*.mli
	$(OCAMLBUILD) $(OBFLAGS) pef/pef.otarget
	@for i in _build/pef/pef.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/csw.%: opencsw/*.ml $(DOSELIBS)/versioning.%
	$(OCAMLBUILD) $(OBFLAGS) opencsw/csw.otarget
	@for i in _build/opencsw/csw.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ; \
	  fi ; \
	done

$(DOSELIBS)/doseparse.%: $(DOSELIBS)/pef.% $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) doseparse/doseparse.otarget
	@for i in _build/doseparse/doseparse.*; do \
	  if [ -e $$i ]; then \
	  cp $$i $(DOSELIBS) ; \
		rm $$i ;\
	  rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx $(DOSELIBS)/*.ml ; \
	  fi ; \
	done

$(DOSELIBS)/doseparseNoRpm.%: $(DOSELIBS)/pef.% $(DOSELIBS)/debian.%
	$(OCAMLBUILD) $(OBFLAGS) doseparseNoRpm/doseparseNoRpm.otarget
	@for i in _build/doseparseNoRpm/doseparseNoRpm.*; do \
	  if [ -e $$i ]; then \
			cp $$i $(DOSELIBS) ;\
			rm $$i ;\
			rm -f $(DOSELIBS)/*.mlpack $(DOSELIBS)/*.cmx ;\
	  fi ; \
	done

clean:
	$(OCAMLBUILD) -clean
	@$(shell \
		for lib in $(LIBNAMES); do \
			libname=`basename "$$lib"` ;\
			dirname=`dirname "$$lib"` ;\
			rm -f $$dirname/$$libname.itarget ;\
		done)
	rm -f myocamlbuild.ml
	rm -f applications/apps.itarget
	rm -f doseparseNoRpm doseparse/doseparseNoRpm.mlpack
	cd doc && $(MAKE) clean

distclean: clean
	rm -Rf Makefile.config aclocal.m4 config.log config.status autom4te.cache/
	rm -f algo/algo.mlpack
	rm -f common/versionInfo.ml
	rm -f db/db.mlpack
	rm -f _tags META applications/dose-tests.list dose3.odocl

test: apps
ifeq (libs,$(word 2,$(MAKECMDGOALS)))
	$(MAKE) testlib
else
ifdef group
	applications/dose-tests.py --rungroup $(group) applications/dose-tests.list
else 
ifdef unit
	applications/dose-tests.py --runtest $(unit) applications/dose-tests.list
else
	$(MAKE) testlib
	applications/dose-tests.py applications/dose-tests.list
endif
endif
endif

testlib: 
	echo $(TESTS)
	@for i in $(TESTS); do\
		echo "#######START TESTING $$i" ;\
		$(OCAMLBUILD) $(APPFLAGS) $$i/tests.$(OCAMLEXT) || exit 1;\
		./tests.$(OCAMLEXT) || exit 1;\
	done

# stuff not not put in a distribution tarball
DIST_EXCLUDE = cudf tests $(wildcard */tests) experimental doc/webpages

INSTALL_STUFF_ = META
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cma _build/doselibs/*.cmi)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.cmxa _build/doselibs/*.cmxs)
INSTALL_STUFF_ += $(wildcard _build/doselibs/*.a)
#INSTALL_STUFF_ += $(wildcard _build/*/*.mli)
INSTALL_STUFF_ += $(wildcard _build/rpm/*.so)

exclude_cudf = $(wildcard _build/doselibs/*cudf* _build/cudf/*)
INSTALL_STUFF = $(filter-out $(exclude_cudf), $(INSTALL_STUFF_))

installlib: META installcudf
	@test -d $(LIBDIR) || mkdir -p $(LIBDIR)
	@test -d $(LIBDIR)/stublibs || mkdir -p $(LIBDIR)/stublibs
	@$(INSTALL) -patch-version $(VERSION) $(NAME) $(INSTALL_STUFF)
	@echo "Install dose librairies to $(LIBDIR)"

install: installlib
	@cd _build/applications ; \
	install -d $(BINDIR) ; \
	for f in $$(ls *.$(OCAMLEXT)) ; do \
		install $(INSTALLOPTS) $$f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
	done
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/debcheck$(EXE)
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/rpmcheck$(EXE)
	@$(LN) $(BINDIR)/distcheck $(BINDIR)/eclipsecheck$(EXE)
	@echo "Install dose binaries to $(BINDIR)"

uninstalllib:
	@$(OCAMLFIND) remove -destdir $(LIBDIR) $(NAME)
	@echo "Uninstall dose librairies from $(LIBDIR)"

uninstall: uninstalllib uninstallcudf
	@for f in $$(ls *.$(OCAMLEXT)) ; do \
	  rm -f $(BINDIR)/$${f%.$(OCAMLEXT)}$(EXE) ; \
	done
	@rm -f $(BINDIR)/debcheck$(EXE) $(BINDIR)/rpmcheck$(EXE) $(BINDIR)/eclipsecheck$(EXE)
	@echo "Uninstall dose binaries from $(BINDIR)"

dist: ./$(DIST_TARBALL)
./$(DIST_TARBALL):
	@if [ -d ./$(DIST_DIR)/ ] ; then rm -rf ./$(DIST_DIR)/ ; fi
	@if [ -d ./$(DIST_TARBALL) ] ; then rm -f ./$(DIST_TARBALL) ; fi
	@mkdir ./$(DIST_DIR)/ ; git archive --format=tar HEAD | tar -x -C ./$(DIST_DIR)/
	@for f in $(DIST_EXCLUDE) ; do rm -rf ./$(DIST_DIR)/$$f; done
	@tar czf ./$(DIST_TARBALL) ./$(DIST_DIR)
	@rm -rf ./$(DIST_DIR)
	@echo "Distribution tarball: ./$(DIST_TARBALL)"

changelog:
	dch -c CHANGES --package $(NAME) -v $(VERSION)

credits:
	@git log --pretty=format:'%aN        %aE' | LC_ALL=C sort -u | awk -F'\t' '{printf("\t%s <%s>\n",$$1,$$2)}';

doc: all
	$(OCAMLBUILD) -package unix scripts/pack.$(OCAMLEXT)
	scripts/doc.sh $(OCAMLEXT)
	dot -Grotate=0 -Tsvg -o dose3.docdir/index.svg dose3.docdir/index.dot
	(cd doc && $(MAKE) all)

man:
	cd doc/manpages && $(MAKE)

upload: doc
	(cd doc && $(MAKE) upload)
	rsync -avz -O dose3.docdir/ scm.gforge.inria.fr:/home/groups/dose/htdocs/API/

.PHONY: \
	common algo pef versioning debian rpm csw doseparseNoRpm doseparse \
	all clean top-level headers test tags install uninstall dist doc man

=== doc/Makefile ===
SUBDIRS = manpages debcheck.primer apt-external-solvers.primer
SHELL=/bin/bash

all:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE)); \
	done

clean:
	@for subdir in $(SUBDIRS); do \
	  (cd $$subdir && $(MAKE) clean); \
	done

webpages:
	cd webpages && $(MAKE) rebuild

upload: webpages
	rsync -avz -O --delete --no-perms webpages/public_html/* scm.gforge.inria.fr:/home/groups/dose/htdocs/

=== doc/apt-external-solvers.primer/Makefile ===
MAIN=apt-external-solvers
SHELL=/bin/bash
HEVEA=hevea -exec xxdate.exe
DEPS = $(wildcard *.tex) version.tex mancoosi.bib

all: html ps pdf

include ../../Makefile.config

html: $(MAIN).html 

ps: $(MAIN).ps

pdf: $(MAIN).pdf


$(MAIN).html: $(DEPS) $(MAIN).aux
	$(HEVEA) -fix $(MAIN).tex

$(MAIN).ps: $(MAIN).dvi
	dvips $<

$(MAIN).pdf: $(DEPS)
	pdflatex $(MAIN)

$(MAIN).dvi: $(DEPS)
	latex $(MAIN)

$(MAIN).aux: $(DEPS)
	latex $(MAIN)

version.tex:
	echo -n "\\def\\version{" >> $@
	echo -n $(VERSION) >> $@
	echo "}" >> $@

headers:
	headache -h headache.header -c headache.conf $(DEPS)

distclean clean:
	-rm -f $(MAIN).{dvi,aux,toc,haux,htoc,log,bbl,blg,html,ps,pdf}\
		 version.tex

.phony: clean distclean headers all ps pdf html

=== doc/manpages/Makefile ===
# all pod files
PODA = $(wildcard *.pod)
# pod files per section
POD5 = apt-cudf.conf.pod
POD8 = apt-cudf-get.pod
POD1 = $(filter-out $(POD5) $(POD8),$(PODA))

# manpages to be generated
MAN1 = $(patsubst %.pod,%.1,$(POD1))
MAN5 = $(patsubst %.pod,%.5,$(POD5))
MAN8 = $(patsubst %.pod,%.8,$(POD8))
MANA = $(MAN1) $(MAN5) $(MAN8)

# manpages in HTML to be generated
HTMLA = $(patsubst %.pod,%.html,$(PODA))

all: man html

man: $(MANA)

html: $(HTMLA)

%.1: %.pod
	pod2man --section 1 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.5: %.pod
	pod2man --section 5 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.8: %.pod
	pod2man --section 8 --center="DOSE Tools" \
		--release "$(NAME) $(VERSION)" $*.pod > $@

%.html: %.pod
	pod2html $*.pod > $@

distclean clean:
	rm -f $(MANA) $(HTMLA) pod2htmd.tmp pod2htmi.tmp

.PHONY: clean distclean man html all

=== debian/changelog ===
dose3 (5.0.1-9build3) bionic; urgency=medium

  * No-change rebuild for librpm soname bump.

 -- Matthias Klose <doko@debian.org>  Sun, 12 Nov 2017 15:15:39 +0100

dose3 (5.0.1-9build2) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Oct 2017 16:38:56 +0200

dose3 (5.0.1-9build1) artful; urgency=high

  * No change rebuild against new ocaml abis.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 31 Aug 2017 02:11:25 +0100

dose3 (5.0.1-9) unstable; urgency=medium

  * patch virtual_provides: packages that provide the same virtual package
    in different versions, or that provide the same versioned virtual package
    as a real package, are co-installable (closes: #867104, #864906).
  * add a test-case for bug  #867104
  * dose-doc: set Multi-Arch=foreign
  * add build-dependency on ocamlbuild
  * standards-version 4.0.0 (no change)

 -- Ralf Treinen <treinen@debian.org>  Wed, 19 Jul 2017 10:19:10 +0200

dose3 (5.0.1-8) unstable; urgency=medium

  * Patches taken from upstream (thanks, Josch!)
    - architecture-tuples: replace architecture triples by tuples.
      (closes: #843409)
    - architectures-dpkg-1.18.15: Update embedded cputable and tupletable
      to dpkg 1.18.15
    - deb-drop-d-b-arch: add support for --deb-drop-b-d-arch (closes: #850943)

 -- Ralf Treinen <treinen@debian.org>  Tue, 17 Jan 2017 22:14:21 +0100

dose3 (5.0.1-7) unstable; urgency=medium

  * use pic options only on native architectures.

 -- Ralf Treinen <treinen@debian.org>  Thu, 03 Nov 2016 13:23:49 +0100

dose3 (5.0.1-6) unstable; urgency=medium

  * New patch ocaml-4.02.3+gcc-6.2.0 as provided by Josch: fix FTBFS. This
    patch should probably be removed when we transition to ocaml 4.03.

 -- Ralf Treinen <treinen@debian.org>  Thu, 27 Oct 2016 08:55:57 +0200

dose3 (5.0.1-4) unstable; urgency=medium

  * Revert the change introduced by 5.0.1-3, since it makes the
    autobuilders fail.

 -- Ralf Treinen <treinen@debian.org>  Wed, 26 Oct 2016 08:18:30 +0200

dose3 (5.0.1-3) unstable; urgency=medium

  * Added build-dependency "ocamlbuild|ocaml-nox(<<4.03)", in view of the
    transition to ocaml 4.03 which does no longer include ocamlbuild.

 -- Ralf Treinen <treinen@debian.org>  Tue, 25 Oct 2016 22:03:12 +0200

dose3 (5.0.1-2) unstable; urgency=medium

  [ Johannes Schauer ]
  * Backport more commits from upstream to fix remaining bugs considering
    - the handling of Essential:yes packages:
        0003-applications-distcheck.ml-Consider-essential-package.patch
        0007-applications-deb-buildcheck.ml-fix-regression-that-l.patch
        0008-Catch-expection-in-diagnostic.ml.patch
    - library bugs that affect packages using libdose3-dev:
        0004-doseparse-stdUtils.ml-It-s-d.byte-and-not-p.byte-for.patch
        0005-algo-depsolver.ml-reset-progress-bar-after-univcheck.patch
        0006-algo-depsolver.ml-set-correct-value-for-Util.Progres.patch

  [ Ralf Treinen ]
  * Patch input-xz-files: accept input from xz-compressed files.
    Add dependency on xz-utils.

 -- Ralf Treinen <treinen@debian.org>  Sun, 16 Oct 2016 19:36:29 +0200

dose3 (5.0.1-1) unstable; urgency=medium

  * new upstream release
  * remove patches distcheck-fg-bg and getrealname as they have been
    incorporated upstream
  * backport patches
    0001-check_request_using-can-return-discording-result-bet.patch and
    0002-tentative-fix-for-missing-essential-problem-apt-cudf.patch from
    upstream git to fix missing Essential:yes packages when invoking external
    solvers

 -- Johannes Schauer <josch@debian.org>  Thu, 08 Sep 2016 23:05:40 +0200

=== debian/control ===
--- 
+++ 
@@ -1,23 +1,26 @@
 Source: dose3
 Section: ocaml
 Priority: extra
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stefano Zacchiroli <zack@debian.org>,
  Ralf Treinen <treinen@debian.org>,
  Johannes Schauer <josch@debian.org>
 Build-Depends: debhelper (>= 9), dh-ocaml (>= 0.9~), dh-autoreconf,
 # use the following line only when autoconf stuff has been patched:
 # automake, autoconf,
- ocaml-nox (>= 3.11.2), cppo (>= 0.9.3),
+ ocaml-nox (>= 3.11.2), cppo (>= 1.1.2),
+# drop ocamlbuild when backporting to ocaml << 4.02.3-10 
+ ocamlbuild,
  libre-ocaml-dev,
- libextlib-ocaml-dev (>= 1.6.1),
- libocamlgraph-ocaml-dev (>= 1.8.5),
+ libextlib-ocaml-dev (>= 1.7.0),
+ libocamlgraph-ocaml-dev (>= 1.8.6),
  libcudf-ocaml-dev (>= 0.7),
  libzip-ocaml-dev, libbz2-ocaml-dev, librpm-dev (>= 4.12),
  perl 
 Build-Depends-Indep: graphviz,
  hevea, texlive-latex-base, texlive-latex-extra
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.mancoosi.org/software/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/dose3.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/dose3.git
@@ -64,7 +67,7 @@
 Package: dose-distcheck
 Section: devel
 Architecture: any
-Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}, xz-utils
 Breaks: dose3-distcheck (<< 2.9.13)
 Replaces: dose3-distcheck (<< 2.9.13)
 Description: Checks whether dependencies of packages can be satisfied
@@ -78,7 +81,7 @@
 Package: dose-builddebcheck
 Section: devel
 Architecture: any
-Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}, xz-utils
 Breaks: dose3-builddebcheck (<< 2.9.13)
 Replaces: dose3-builddebcheck (<< 2.9.13)
 Description: Checks whether build-dependencies can be satisfied
@@ -93,7 +96,7 @@
 Provides: ceve
 Breaks: ceve (<< 2.9.10)
 Replaces: ceve (<< 2.9.10)
-Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}
+Depends: ${ocaml:Depends}, ${misc:Depends}, ${shlibs:Depends}, xz-utils
 Description: Extra QA tools from the Dose3-library
  This package contains extra tools for analyzing meta-data of software 
  packages:
@@ -142,6 +145,7 @@
 Breaks: libdose3-ocaml-dev (<< 4.3-2),
 	  apt-cudf (<< 4.3-2),
 	  dose-distcheck (<< 4.3-2)
+Multi-Arch: foreign    
 Description: Documentation for dose tools and libraries.
  The dose suite provides libraries for handling package meta-data, and various
  tools for analyzing package relationships in a large package repository.

=== debian/tests/control ===
Tests: dose-debcheck bug811569 bug790422 bug867104
Depends: dose-distcheck

Tests: dose-builddebcheck
Depends: dose-builddebcheck

Tests: dose-outdated
Depends: dose-extra

=== debian/watch ===
version=3
opts=uversionmangle=s/-/~/ \
https://gforge.inria.fr/frs/?group_id=4395 .*/dose3-(.*)\.tar\.gz

## dose3 6.0.1

=== doc/manpages/Makefile ===
PODA = $(wildcard *.rst)
# pod files per section
POD5 = apt-cudf.conf.rst
POD8 = apt-cudf-get.rst
POD1 = $(filter-out $(POD5) $(POD8),$(PODA))

# manpages to be generated
MAN1 = $(patsubst %.rst,%.1,$(POD1))
MAN5 = $(patsubst %.rst,%.5,$(POD5))
MAN8 = $(patsubst %.rst,%.8,$(POD8))
MANA = $(MAN1) $(MAN5) $(MAN8)

# manpages in HTML to be generated
HTMLA = $(patsubst %.rst,%.html,$(PODA))

all: man html

man: $(MANA)

html: $(HTMLA)

%.1: %.rst
	pandoc -s -t man $*.rst -o $@

%.5: %.rst
	pandoc -s -t man $*.rst -o $@

%.8: %.rst
	pandoc -s -t man $*.rst -o $@

%.html: %.rst
	pandoc -s -t html $*.rst -o $@

distclean clean:
	rm -f $(MANA) $(HTMLA)

.PHONY: clean distclean man html all

=== doc/rtd/Makefile ===
# You can set these variables from the command line.
SPHINXOPTS    = -aE -n
SPHINXBUILD   = poetry run sphinx-build
SPHINXPROJ    = Tezos
SOURCEDIR     = .
BUILDDIR      = _build

all: html linkcheck

linkcheck:
	$(SPHINXBUILD) -b linkcheck "$(SOURCEDIR)" "$(BUILDDIR)"

html: Makefile
	$(SPHINXBUILD) -b html "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS)

clean:
	@-rm -Rf "$(BUILDDIR)"

=== debian/changelog ===
dose3 (6.0.1-2) unstable; urgency=medium

  * d/rules, d/control: split into arch/indep
  * debian/control: annotate with nodoc and nocheck
  * debian/control: fix version constraints

 -- Johannes 'josch' Schauer <josch@debian.org>  Tue, 02 Feb 2021 11:58:25 +0100

dose3 (6.0.1-1) unstable; urgency=medium

  * New upstream version
  * debian/watch: upstream moved to gitlab.com/irill/dose3
  * debian/rules:
     - buildsystem switched to dune
     - call dune build -p dose3 to avoid 'Error: Too many opam files
       for package'
     - add DEB_BUILD_MAINT_OPTIONS = hardening=+all
     - check DEB_BUILD_OPTIONS for nocheck before running tests
     - do not override_dh_dwz anymore
  * debian/control:
     - adjust build dependencies
     - add Rules-Requires-Root: no
     - bump Standards-Version to 4.5.1
     - bump dh compat to 13 and use debhelper-compat as B-D
     - drop libdose3-ocaml package as there are no shared runtime stubs anymore
  * debian/patches:
     - drop patches: everything is now upstream
     - add patch for ocamlgraph 1.8.6
     - pick two patches from upstream to fix FTBFS
     - add patch making dose3 tests succeed on 32 bit arches
  * fix paths in *.install and *.manpages and *.docs
  * debian/copyright: fix paths that were moved into src
  * debian/update-cudf-solvers: fix typo opearte -> operate
  * run wrap-and-sort

 -- Johannes 'josch' Schauer <josch@debian.org>  Mon, 01 Feb 2021 23:08:16 +0100

dose3 (5.0.1-16) unstable; urgency=medium

  * Team upload
  * Do not use -custom (Closes: #978024)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 06 Jan 2021 16:21:12 +0100

dose3 (5.0.1-15) unstable; urgency=medium

  * add debian/salsa-ci.yml
  * debian/control: fix my name
  * add patch to handle m-a:same conflicts with virtual packages (closes: #964026)

 -- Johannes 'josch' Schauer <josch@debian.org>  Sun, 12 Jul 2020 11:02:29 +0200

dose3 (5.0.1-14) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Compile with -safe-string (Closes: #934347)

  [ Ralf Treinen ]
  * fix spelling error in the long description of dose-extra

 -- Stéphane Glondu <glondu@debian.org>  Sun, 11 Aug 2019 17:07:27 +0200

dose3 (5.0.1-12) unstable; urgency=medium

  * Standards-Version 4.3.0 (no change)
  * Fix whitespace in debian/{changelog,control}
  * libdose3-ocaml-dev: Recommends ocaml-findlib

 -- Ralf Treinen <treinen@debian.org>  Fri, 26 Jul 2019 16:07:51 -0300

dose3 (5.0.1-11) unstable; urgency=medium

  * Team upload
  * Add a patch to build with ocaml-re 1.7.3 and constraint minimal
    required version for ocaml-re in d/control accordingly.
  * Update Vcs-* fields
  * Refresh patches

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 03 Jun 2018 11:14:38 +0200

dose3 (5.0.1-10) unstable; urgency=medium

  * Added a test case for dose-builddebcheck with versioned provides and
    a versioned build-dependency, taken from James Clarkes bug report
    #896084.
  * Patch 0009-Fix-and-constraints-against-virtual-packages.patch: fix
    cudf encoding of versioned and unversioned virtual packages. Thanks a
    lot to James Clarke for the patch! (closes: #896084)
  * Patch typo-plural: fix some occurrences of "does not exists"
    (closes:  #869846).
  * Refreshed patch deb-drop-b-d-arch
  * Standards-Version 4.1.4:
    - Changed Priority from extra to optional
    - d/copyright: https in format url

 -- Ralf Treinen <treinen@debian.org>  Sat, 21 Apr 2018 17:05:24 +0200

=== debian/control ===
Source: dose3
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stefano Zacchiroli <zack@debian.org>,
           Ralf Treinen <treinen@debian.org>,
           Johannes 'josch' Schauer <josch@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-ocaml (>= 0.9~),
               libbase64-ocaml-dev (>= 3.1.0),
               libbz2-ocaml-dev (>= 0.6.0-10~),
               libcudf-ocaml-dev (>= 0.7),
               libextlib-ocaml-dev (>= 1.7.7),
               libocamlgraph-ocaml-dev (>= 1.8.6),
               libre-ocaml-dev (>= 1.7.2~),
               libzip-ocaml-dev (>= 1.08),
               ocaml-dune (>= 2.7.1),
               ocaml-nox (>= 4.03),
               pandoc
Build-Depends-Arch: grep-dctrl <!nocheck>,
                    libounit-ocaml-dev <!nocheck>,
                    libparmap-ocaml-dev,
                    perl,
                    python3-yaml <!nocheck>,
                    xz-utils <!nocheck>
Build-Depends-Indep: graphviz <!nodoc>,
                     hevea <!nodoc>,
                     lmodern <!nodoc>,
                     ocaml-odoc <!nodoc>,
                     texlive-latex-base <!nodoc>,
                     texlive-latex-extra <!nodoc>
Standards-Version: 4.5.1
Homepage: http://www.mancoosi.org/software/
Vcs-Browser: https://salsa.debian.org/ocaml-team/dose3
Vcs-Git: https://salsa.debian.org/ocaml-team/dose3.git
Rules-Requires-Root: no

Package: libdose3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: ocaml-findlib
Provides: ${ocaml:Provides}
Description: OCaml libraries for package dependencies (development files)
 Dose3 is a framework consisting of several OCaml libraries for analysing
 the metadata of software packages (like Packages files of Debian suites).
 .
 Though not tied to any particular distribution, Dose3 constitutes a
 pool of libraries which enable analyzing packages coming from various
 distributions.
 .
 Besides basic functionalities for querying and setting package
 properties, dose3 also implements algorithms for solving more complex
 problems (monitoring package evolutions, correct and complete
 dependency resolution, repository-wide uninstallability checks).
 .
 This package contains the development stuff you need to use dose3 for
 the development of programs.

Package: dose-distcheck
Section: devel
Architecture: any
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Breaks: dose3-distcheck (<< 2.9.13)
Replaces: dose3-distcheck (<< 2.9.13)
Description: Checks whether dependencies of packages can be satisfied
 This software checks for every package of a distribution whether it
 is possible to satisfy its dependencies and conflicts within this
 distribution. It comes in several versions:
  - dose-debcheck for Debian packages
  - dose-rpmcheck for rpm packages
  - dose-eclipsecheck for OSGi plugins

Package: dose-builddebcheck
Section: devel
Architecture: any
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Breaks: dose3-builddebcheck (<< 2.9.13)
Replaces: dose3-builddebcheck (<< 2.9.13)
Description: Checks whether build-dependencies can be satisfied
 This software checks, given a collection of source package stanzas
 and a collection of binary package stanzas of Debian packages, whether
 the build-dependencies of each source package can be satisfied by the
 binary packages.

Package: dose-extra
Section: devel
Architecture: any
Provides: ceve
Breaks: ceve (<< 2.9.10)
Replaces: ceve (<< 2.9.10)
Depends: xz-utils, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Description: Extra QA tools from the Dose3-library
 This package contains extra tools for analyzing meta-data of software
 packages:
  - ceve, a general metadata parser supporting different input formats
    (Debian, rpm, and others) and different output formats.
  - dose-outdated, a Debian-specific tool for finding packages that are not
    installable with respect to a package repository, and that can only be
    made installable again by fixing the package itself.
  - dose-challenged, a Debian-specific tool for checking which packages
    will certainly become uninstallable when some existing package is upgraded
    to a newer version.
  - dose-deb-coinstall, a Debian-specific tool for checking whether a set of
    packages can be installed all together.
 The tools dose-distcheck and dose-builddebcheck are packaged in their
 own respective packages.

Package: apt-cudf
Section: admin
Architecture: any
Depends: aspcud | cudf-solver,
         ${misc:Depends},
         ${ocaml:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Description: CUDF solver integration for APT
 apt-cudf provides integration among the APT package manager and CUDF solvers,
 allowing APT to rely on external (CUDF-based) dependency solvers to plan
 package installation, upgrade, and removal.
 .
 CUDF is a distribution-independent, standard format to describe dependency
 solving scenarios, as faced by package managers in popular package-based
 GNU/Linux distributions. APT is a well-known package manager for Debian-based
 distributions, which is able to delegate dependency solving to external
 solvers, by the means of the External Dependency Solving Protocol (EDSP).
 .
 apt-cudf provides the glue between the EDSP protocol and CUDF solvers,
 enabling any installed CUDF solver to be used as an external solver for APT.
 .
 Several CUDF solvers are available in Debian. They all provide the cudf-solver
 virtual package.

Package: dose-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: apt-cudf (<< 4.3-2),
          dose-distcheck (<< 4.3-2),
          libdose3-ocaml-dev (<< 4.3-2)
Breaks: apt-cudf (<< 4.3-2),
        dose-distcheck (<< 4.3-2),
        libdose3-ocaml-dev (<< 4.3-2)
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: Documentation for dose tools and libraries.
 The dose suite provides libraries for handling package meta-data, and various
 tools for analyzing package relationships in a large package repository.
 This package contains the documentation of the dose API, and tutorials of
 various dose tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DESTDIR=$(CURDIR)/debian/tmp
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

# Instead of running "dune build" via "make all" we run dune with -p dose3
# because otherwise we get this error on salsaci:
# Error: Too many opam files for package "dose3":
# - debian/output/source_dir/dose3.opam
# - dose3.opam
override_dh_auto_build-arch:
	dune build -p dose3 @install --verbose
	make -C doc/manpages man
	pod2man --section 8 -release "apt-cudf $(RELEASE)" \
		debian/update-cudf-solvers > debian/update-cudf-solvers.8

override_dh_auto_build-indep:
	dune build -p dose3 @doc
	# running targets manually because we don't want to build the "pages"
	make -C doc/debcheck.primer
	make -C doc/apt-external-solvers.primer
	make -C doc/manpages html

override_dh_auto_install-arch:
	dune install -p dose3 --destdir=$(DESTDIR) --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
	rm -f $(DESTDIR)/usr/doc/dose3/README.git
	rm -f $(DESTDIR)/usr/doc/dose3/README.architecture
	rm -f $(DESTDIR)/usr/doc/dose3/CHANGES

# No install or test needed for docs
override_dh_auto_test-indep:
override_dh_auto_install-indep:

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dune runtest -p dose3
endif

=== debian/watch ===
version=4
https://gitlab.com/irill/dose3/tags?sort=updated_desc .*/archive/[0-9.]+/dose3-([0-9.]+)\.tar\.gz
